﻿# Example #1 Version

##  Open in both PowerShell ISE AND Visual Studio Code

$PSVersionTable

## MAKE SURE TO RUN APP AS ADMINISTRATOR

#=========================================================================

# Example #2 Verb-Noun

Get-Service "SQL*"  # Start with SQL
Get-Service -Name "SQL*" 


Get-Service "*SQL*"  # Has SQL in the name


Copy-Item "C:\PowerShellCopyExample\source\copy.txt" -Destination "C:\PowerShellCopyExample\target" 

##  Copy-Item -Path "C:\Logfiles\*" -Destination "C:\Drawings\Logs" -Recurse   ## will copy everything from the C:\LogFiles folder


#=========================================================================

# Example #3 Comments

# this is a comment
# <get-service>
<#
       This is a comment block
#>
Get-Service "SQL*" 

Get-Service "SQL*"  # Start with SQL

#=========================================================================

# Example #4 Variables and IF statement

$Today = (Get-Date).DateTime

Write-Output $Today



[int]$type = 6  
$type
$type = 55 # change this to 54 for demo
$type
#uncomment the next line
# $type = "What will happen?"


# -eq -ne (Not equal)-ieq case-insensitive equality -ceq case-sensitive equality
If ($type -eq 55)
    {
        Write-Output "Variable = 55"
    }
ELSE
    {
        Write-Output "Variable is not equal to 55"
    }
#------------------------------------------------------------------------
            If ($type -eq 55){
        Write-Output "Variable = 55"
  }
ELSE
    {Write-Output "Variable is not equal to 55 - Bad formatting"
    }
#=========================================================================


##  SWITCH TO PowerShell ISE if not already using it.

# Example #5 Parameters

Invoke-Sqlcmd -Query "SELECT GETDATE() AS TimeOfQuery" -ServerInstance "LocalHost"


#=========================================================================

# Example #6

Get-History

Get-History -Count 1  # Most Recent command

Get-History | Where-Object {$_.CommandLine -like "*Service*"}

# run to add to history

Get-Help


#=========================================================================

# Example #7

# start Notepad

Start-Process 'C:\windows\system32\notepad.exe'


$npad = Get-Process notepad -ErrorAction SilentlyContinue

$npad

if ($npad) {
  
  # kill after 10 seconds
  Sleep 10
  if (!$npad.HasExited) {
    $npad | Stop-Process -Force
  }
}

# Remove-Variable npad

#==============================================================

# variable Clear vs Remove

$Name = "Dave"


$Name

Clear-Variable Name

$Name

Remove-Variable Name


#==============================================================

# Example #8 Pipes

# Start Notepad

Get-Process notepad | Stop-Process


#==============================================================

# Example $9 Switch

# Open Services

services.msc

## Check the status of a service

$server = $env:computername 

$object = Get-service -ComputerName $server  | where {( $_.name -like "MSSQLSERVER" -or $_.name -like "SQL Server (*") } -ErrorAction SilentlyContinue
if ($object)

{

$instDetails= $object |select Status


#$instDetails
  

Switch ($instDetails.status)
    {
        "Running" {Write-Host "Is Running"}
        "Stopped" {Write-Host "Is Stopped"}
        "Paused" {Write-Host "Is Paused"}
    }

}else

{

Write-Host "0 SQL Server instances discovered"

}

Get-Service -Name "MSSQLSERVER" | Stop-Service

Get-Service -Name "SQLSERVERAGENT" | Stop-Service

Get-Service -DisplayName "SQL Server Agent (MSSQLSERVER)" | Stop-Service

Get-Service -Name "MSSQLSERVER" | Start-Service

Get-Service -Name "MSSQLSERVER" | Resume-Service

Get-Service -Name "MSSQLSERVER" | Suspend-Service



